unit uDASampleDriver;

{----------------------------------------------------------------------------}
{ Data Abstract Library - Driver Library
{
{ compiler: Delphi 6 and up
{ platform: Win32
{
{ (c)opyright RemObjects Software. all rights reserved.
{
{ Using this code requires a valid license of the Data Abstract
{ which can be obtained at http://www.remobjects.com.
{----------------------------------------------------------------------------}

{$I ..\DataAbstract.inc}

{$R DataAbstract_SampleDriver_Glyphs.res}

interface
{$DEFINE SAMPLE}
uses 
  {$IFDEF DELPHIXE2UP}
    System.SysUtils, System.Classes, System.Variants,
    Data.DB,
  {$ELSE}
    SysUtils, Classes, Variants, DB,
  {$ENDIF}
  // put here your DAC files
  // uDAADOInterfaces, {for ADO}
  // uDAIBInterfaces,  {for IB}
  // uDAOracleInterfaces, {for Oracle}
  uROStrings,
  uDACore, uDAEngine, uDAServerInterfaces,  uDASQLMacroProcessor,
  uDAUtils, uDAEConnection, uDAFields,
  uDADriverForeignKey, uDASchemaClasses, uDAQueryBuilder, uDASQLQueryGenerator;
  

type { TDASampleDriver }
  TDASampleDriver = class(TDADriverReference)
  end;

  { TDAESampleDriver }
  TDAESampleDriver = class(TDAEDriver ,IDADriver40)
    //  TDAESampleDriver = class(TDAIBDriver, IDADriver40)
  protected
    function GetConnectionClass: TDAEConnectionClass; override;
    //procedure CustomizeConnectionObject(aConnection: TDAEConnection); override;
    //procedure DoSetTraceOptions(TraceActive: boolean; TraceFlags: TDATraceOptions; Callback: TDALogTraceEvent); override;

    { IDADriver }
    function GetDriverID: string; override; safecall;
    function GetDescription: string; override; safecall;
    // function GetMajVersion: byte; override; safecall;
    // function GetMinVersion: byte; override; safecall;
    procedure GetAuxDrivers(out List: IROStrings); override; safecall;
    procedure GetAuxParams(const AuxDriver: string; out List: IROStrings); override;
    // function GetAvailableDriverOptions: TDAAvailableDriverOptions; override; safecall;
    // procedure Initialize; override; safecall;
    // procedure Finalize; override; safecall;
    // function GetDefaultCustomParameters: string; override; safecall;

    { IDADriver40 }
    function GetProviderDefaultCustomParameters(Provider: string): string; safecall;
  public
  end;

  { TDAESampleConnection }
  TDAESampleConnection = class(TDAEConnection, IDAConnection,
      // IDAADOConnection,
      // IDAInterbaseConnection, IDAIBTransactionAccess, IDAIBConnectionProperties
      // IDAOracleConnection,
      // IDAConnectionModelling,
      // IDACanQueryDatabaseNames,
      // IDAFileBasedDatabase,
      // IDADirectoryBasedDatabase,
      // IDAUseGenerators,
      IDATestableObject)
  private
    // fNativeConnection: TCustomConnection;
  protected
    function QueryInterface(const IID: TGUID; out Obj): HResult; override; stdcall;

    function CreateCustomConnection: TCustomConnection; override;
    //function CreateMacroProcessor: TDASQLMacroProcessor; override;
    function GetDatasetClass: TDAEDatasetClass; override;
    function GetStoredProcedureClass: TDAEStoredProcedureClass; override;
    procedure DoApplyConnectionString(aConnStrParser: TDAConnectionStringParser; aConnectionObject: TCustomConnection); override;

    // transaction support
    function DoBeginTransaction: integer; override;
    procedure DoCommitTransaction; override;
    procedure DoRollbackTransaction; override;
    function DoGetInTransaction: boolean; override;

    // procedure DoGetTableNames(out List: IROStrings); override;
    // procedure DoGetViewNames(out List: IROStrings); override;
    // procedure DoGetStoredProcedureNames(out List: IROStrings); override;

    // procedure DoGetTableFields(const aTableName: string; out Fields: TDAFieldCollection); override;
    // procedure DoGetQueryFields(const aSQL: string; aParamsIfNeeded: TDAParamCollection; out Fields: TDAFieldCollection); override;
    // procedure DoGetViewFields(const aViewName: string; out Fields: TDAFieldCollection); override;

    // procedure DoGetStoredProcedureParams(const aStoredProcedureName: string; out Params: TDAParamCollection); override;
    // procedure DoGetForeignKeys(out ForeignKeys: TDADriverForeignKeyCollection); override;

    // function DoGetLastAutoInc(const GeneratorName: string): integer; override;

    { IDATestableObject }
    // procedure Test; override; safecall;

    { IDAConnection }
    // UserID/Password
    // function GetUserID: string; override; safecall;
    // procedure SetUserID(const Value: string); override; safecall;
    // function GetPassword: string; override; safecall;
    // procedure SetPassword(const Value: string); override; safecall;

    // function GetSPSelectSyntax(HasArguments: Boolean): string; override; safecall;
    // function GetQuoteChars: TDAQuoteCharArray; override; safecall;
    // function IdentifierIsQuoted(const iIdentifier: string): boolean; override; safecall;
    // function IdentifierNeedsQuoting(const iIdentifier: string): boolean; override; safecall;
    // function QuoteIdentifierIfNeeded(const iIdentifier: string): string; override; safecall;
    // function QuoteIdentifier(const iIdentifier: string): string; override; safecall;
    // function QuoteFieldNameIfNeeded(const aTableName, aFieldName: string): string; override;safecall;
    // function QuoteFieldName(const aTableName, aFieldName: string): string; override; safecall;

    // function NewCommand(const Text: string; CommandType: TDASQLStatementType; const aCommandName: string = ''): IDASQLCommand; override; safecall;
    // function NewDataset(const SQL: string; const aDatasetName: string = ''): IDADataset; override; safecall;
    // function GetLastAutoInc(const GeneratorName: string = ''): integer; safecall;

    // function isAlive: Boolean; override; safecall;
    // function GetQueryBuilder: TDAQueryBuilder; override; safecall;

    { IDAADOConnection }
    // function GetProviderName: string; safecall;
    // function GetProviderType: TDAOleDBProviderType; safecall;
    // function GetCommandTimeout: Integer; safecall;
    // procedure SetCommandTimeout(const Value: Integer); safecall;

    { IDAInterbaseConnection }
    // nothing

    { IDAIBTransactionAccess }
    // function GetTransaction: TObject; safecall;
    // procedure Commit; safecall;
    // procedure CommitRetaining; safecall;
    // procedure Rollback; safecall;
    // procedure RollbackRetaining; safecall;

    { IDAIBConnectionProperties }
    // function GetRole: string; safecall;
    // procedure SetRole(const Value: string); safecall;
    // function GetSQLDialect: integer; safecall;
    // procedure SetSQLDialect(Value: integer); safecall;
    // function GetCharset: string; safecall;
    // procedure SetCharset(const Value: string); safecall;

    // procedure Commit; safecall;
    // procedure CommitRetaining; safecall;
    // procedure Rollback; safecall;
    // procedure RollbackRetaining; safecall;

    { IDAOracleConnection }
    // nothing

    { IDAConnectionModelling }
    // function FieldToDeclaration(aField: TDAField): string; safecall;
    // function BuildCreateTableSQL(aDataSet: TDADataSet; const aOverrideName: string = ''): string; safecall;
    // procedure CreateTable(aDataSet: TDADataSet; const aOverrideName: string = ''); safecall;

    { IDACanQueryDatabaseNames }
    // function GetDatabaseNames: IROStrings;

    { IDAFileBasedDatabase }
    // function GetFileExtensions: IROStrings;

    { IDADirectoryBasedDatabase }
    // nothing

    { IDAUseGenerators }
    // function GetNextAutoinc(const GeneratorName: string): integer; safecall;

  public
    constructor Create(aDriver: TDAEDriver; aName: string = ''); override;
  end;

  { TDAESampleQuery }
  TDAESampleQuery = class(TDAEDataset, IDASQLCommand {, IDAMustSetParams})
  protected
    // procedure PrepareSQLStatement; override;
    function CreateDataset(aConnection: TDAEConnection): TDataset; override;
    // procedure DoPrepare(Value: boolean); override; safecall;
    // function DoExecute: integer; override; safecall;
    procedure DoSetSQL(const Value: string); override; safecall;
    function DoGetSQL: string; override; safecall;
    // function intVCLTypeToDAType(aFieldType: TFieldType): TDADataType;override;

    { IDASQLCommand }
    // procedure RefreshParams; override; safecall;
    // function Execute: integer; override; safecall;
    // function DoGetRecordCount: integer; override;
    // function DoGetActive: boolean; override;
    // procedure DoSetActive(Value: boolean); override;
    // function DoGetBOF: boolean; override;
    // function DoGetEOF: boolean; override;
    // procedure DoNext; override;
    // function DoLocate(const KeyFields: string; const KeyValues: Variant; Options: TLocateOptions): Boolean; override;

    // IDAMustSetParams
    //  procedure SetParamValues(Params: TDAParamCollection); safecall;
    //  procedure GetParamValues(Params: TDAParamCollection); safecall;
  public
  end;

  { TDAESampleStoredProcedure }
  TDAESampleStoredProcedure = class(TDAEStoredProcedure, IDAStoredProcedure {, IDAMustSetParams})
  protected
    // Internal
    // function DoGetStoredProcedureName: string; override;
    // procedure DoSetStoredProcedureName(const Name: string); override;
    // procedure DoPrepare(Value: boolean); override;
    // procedure RefreshParams; override; safecall;

    // IDAStoredProcedure
    function GetStoredProcedureName: string; override; safecall;
    procedure SetStoredProcedureName(const Name: string); override; safecall;

    // procedure PrepareSQLStatement; override;
    function CreateDataset(aConnection: TDAEConnection): TDataset; override;
    // procedure DoPrepare(Value: boolean); override; safecall;
    // function DoExecute: integer; override; safecall;
    // function intVCLTypeToDAType(aFieldType: TFieldType): TDADataType;override;

    { IDASQLCommand }
    // procedure RefreshParams; override; safecall;
    // function Execute: integer; override; safecall;
    // function DoGetRecordCount: integer; override;
    // function DoGetActive: boolean; override;
    // procedure DoSetActive(Value: boolean); override;
    // function DoGetBOF: boolean; override;
    // function DoGetEOF: boolean; override;
    // procedure DoNext; override;
    // function DoLocate(const KeyFields: string; const KeyValues: Variant; Options: TLocateOptions): Boolean; override;

    // IDAMustSetParams
    //  procedure SetParamValues(Params: TDAParamCollection); safecall;
    //  procedure GetParamValues(Params: TDAParamCollection); safecall;
  end;

procedure Register;

function GetDriverObject: IDADriver; stdcall;

implementation

uses
  uROSystem, uROClasses, uROBinaryHelpers, uROBinaryMemoryStream, uROEncoding,
  uDANativeDatabaseAccessSupport, uDADriverManager, uDAHelpers, uDARes;
  

var
  _driver: TDAEDriver = nil;

procedure Register;
begin
  RegisterComponents(DAPalettePageName, [TDASampleDriver]);
end;

function GetDriverObject: IDADriver;
begin
  if (_driver = nil) then _driver := TDAESampleDriver.Create(nil);
  result := _driver;
end;

{ TDAESampleConnection }

procedure TDAESampleConnection.DoApplyConnectionString(aConnStrParser: TDAConnectionStringParser; aConnectionObject: TCustomConnection);
var
  lConnectionString: string;
  i: Integer;
  sName, sValue: string;
begin
  inherited;
  with aConnStrParser do begin
    lConnectionString := '';

    (*
    if (Self.UserID <> '') then
      fConnection.Database.Params.Add('user_name=' + Self.UserID)
    else
      fConnection.Database.Params.Add('user_name=' + UserID);

    if (Self.Password <> '') then
      fConnection.Database.Params.Add('password=' + Self.Password)
    else
      fConnection.Database.Params.Add('password=' + Password);

    if Server <> '' then
      fConnection.Database.DatabaseName := Server + ':' + Database
    else
      fConnection.Database.DatabaseName := Database;
    *)

    for i := 0 to AuxParamsCount - 1 do begin
      sName := AuxParamNames[i];
      if sName = '' then Continue;
      sValue := AuxParams[AuxParamNames[i]];
      (*
      if AnsiSameText(sName, 'PARAM1') then
        ....
      else if AnsiSameText(sName, 'Param2') then
        ....
      else
      *)
      begin
        if sName[1] = '@' then sName := Pchar(sName) + 1;
        lConnectionString := lConnectionString + sName + '=' + sValue + ';';
      end;
    end;
    //    fNativeConnection.ConnectionString := lConnectionString;
  end;
end;

function TDAESampleConnection.DoBeginTransaction: integer;
begin
  //  result := fNativeConnection.BeginTrans;
  Result := 0;
end;

procedure TDAESampleConnection.DoCommitTransaction;
begin
  //  fNativeConnection.CommitTrans;
end;

function TDAESampleConnection.CreateCustomConnection: TCustomConnection;
begin
  result := nil;
  //  fNativeConnection := nil;
  //  fNativeConnection := TNativeConnection.Create(nil);
  //  fNativeConnection.LoginPrompt := FALSE;
  //  result := fNativeConnection;
end;

function TDAESampleConnection.GetDatasetClass: TDAEDatasetClass;
begin
  result := TDAESampleQuery;
end;

function TDAESampleConnection.GetStoredProcedureClass: TDAEStoredProcedureClass;
begin
  result := TDAESampleStoredProcedure;
end;

procedure TDAESampleConnection.DoRollbackTransaction;
begin
  //  fNativeConnection.RollbackTrans
end;

function TDAESampleConnection.DoGetInTransaction: boolean;
begin
  //  result := fNativeConnection.InTransaction
  Result := False;
end;

function TDAESampleConnection.QueryInterface(const IID: TGUID; out Obj): HResult;
begin
  (*
  Result := E_NOINTERFACE;
  // comparing of GUID can be used for universal drivers, e.g. DBX, BDE, ADO, etc
  if IsEqualGUID(IID, IDAADOConnection) then 
  else if IsEqualGUID(IID, IDAInterbaseConnection) then
  else if IsEqualGUID(IID, IDAIBTransactionAccess) then
  else if IsEqualGUID(IID, IDAIBConnectionProperties) then
  else if IsEqualGUID(IID, IDAOracleConnection) then
  else if IsEqualGUID(IID, IDAConnectionModelling) then
  else if IsEqualGUID(IID, IDACanQueryDatabaseNames) then
  else if IsEqualGUID(IID, IDAFileBasedDatabase) then
  else if IsEqualGUID(IID, IDADirectoryBasedDatabase) then
  else if IsEqualGUID(IID, IDAUseGenerators) then   ;
  *)
  Result := inherited QueryInterface(IID, Obj);
end;

constructor TDAESampleConnection.Create(aDriver: TDAEDriver; aName: string);
begin
  inherited Create(aDriver, aName);
end;

{ TDAESampleDriver }

procedure TDAESampleDriver.GetAuxDrivers(out List: IROStrings);
begin
  inherited;
 // List.Add('Driver1');
 // List.Add('Driver2');
end;

procedure TDAESampleDriver.GetAuxParams(const AuxDriver: string;
  out List: IROStrings);
begin
  inherited;
  // if AuxDriver = 'Driver1' then List.Add('Param1={True,False}');
  // if AuxDriver = 'Driver2' then List.Add('Param2={10,20}');
  // List.Add('Param3={All,None}');
  // List.Add('');
  // List.Add('You can pass any parameters directly to driver. Use the prefix ''@'' for this, e.g.:');
  // List.Add('Param1=True;@Param3=All');
end;

function TDAESampleDriver.GetConnectionClass: TDAEConnectionClass;
begin
  result := TDAESampleConnection;
end;

function TDAESampleDriver.GetDescription: string;
begin
  result := 'DataAbstact Sample Driver';
end;

function TDAESampleDriver.GetDriverID: string;
begin
  result := 'Sample';
end;

function TDAESampleDriver.GetProviderDefaultCustomParameters(
  Provider: string): string;
begin
  Result:='';
  // if Provider = 'Driver1' then Result := 'Param1=True;';
  // if Provider = 'Driver2' then Result := 'Param2=20;';
end;

{ TDAESampleQuery }

function TDAESampleQuery.CreateDataset(aConnection: TDAEConnection): TDataset;
begin
  Result := nil;
  //  result := TADOQuery.Create(nil);
  //  TADOQuery(result).Connection := TDAESampleConnection(aConnection).fNativeConnection;
end;

function TDAESampleQuery.DoGetSQL: string;
begin
  Result := '';
  //  result := TADOQuery(Dataset).SQL.Text;
end;

procedure TDAESampleQuery.DoSetSQL(const Value: string);
begin
  // TADOQuery(Dataset).SQL.Text := Value;
end;

{ TDAESampleStoredProcedure }

function TDAESampleStoredProcedure.CreateDataset(aConnection: TDAEConnection): TDataset;
begin
  result := nil;
  //  result := TADOStoredProc.Create(nil);
  //  TADOStoredProc(result).Connection := TDAESampleConnection(aConnection).fNativeConnection;
end;

function TDAESampleStoredProcedure.GetStoredProcedureName: string;
begin
  Result := '';
end;

procedure TDAESampleStoredProcedure.SetStoredProcedureName(
  const Name: string);
begin
  //
end;

initialization
  _driver := nil;
  RegisterDriverProc(GetDriverObject);
finalization
  UnregisterDriverProc(GetDriverObject);
  FreeAndNIL(_driver);
end.

